<?php
include_once $PATH_TO_CODE."/modules/dungeon/action/abstractchangezonetype.class.php";

class BuildStair extends DungeonAbstractChangeZoneTypeAction {
    function __construct() {
        parent::__construct(DungeonConstante::$ACTION_BUILD_STAIR, DungeonConstante::$ZONE_TYPE_STAIR, DungeonConstante::$ACTION_BUILD_STAIR_COST);
    }

    public function isOkToChange($locBlock, $locZone) {
        $locManageAction = ManageAction::getInstance();
        $locPlayer = $locManageAction->getPlayer();

        if($this->isZonePlainOrRock($locZone)) {
        	return parent::isOkToChange($locBlock, $locZone);
        } else {
            $locManageAction->addPlayerInfo("Target zone is not plain or rock");
        }
        return false;
    }
    private function isZonePlainOrRock($parZone) {
    	return $parZone->zoneType == Constante::$ZONE_TYPE_PLAIN
        || $parZone->zoneType == DungeonConstante::$ZONE_TYPE_ROCK; 
    }
    public function setNewZoneType($parZone) {
    	parent::setNewZoneType($parZone);
    	$locTopZone = $parZone->getTopZone();
    	$locBottomZone = $parZone->getBottomZone();
    	if($locTopZone && $this->isZonePlainOrRock($loTopZone)) {
    		$locTopZone->setZoneType($this->newZoneType);
    	}
    	if($locBottomZone && $this->isZonePlainOrRock($locBottomZone)) {
    		$locBottomZone->setZoneType($this->newZoneType);
    	}
    }
}
?>